package betterwithmods.common.blocks;

import betterwithmods.api.block.IMultiVariants;
import betterwithmods.client.BWCreativeTabs;
import net.minecraft.block.Block;
import net.minecraft.block.material.MapColor;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IStringSerializable;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;

public class BlockCobble extends Block implements IMultiVariants {
    public static final PropertyEnum<EnumCobbleType> TYPE = PropertyEnum.func_177709_a("type", EnumCobbleType.class);

    public BlockCobble() {
        super(Material.field_151576_e);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(TYPE, EnumCobbleType.GRANITE));
        this.func_149711_c(2.0F);
        this.func_149752_b(5.0F);
        this.func_149647_a(BWCreativeTabs.BWTAB);
        this.func_149663_c("bwm:cobble");
    }

    @Override
    public String[] getVariants() {
        return new String[] {"type=granite", "type=diorite", "type=andesite"};
    }

    @Override
    public int func_180651_a(IBlockState state) {
        return state.func_177229_b(TYPE).ordinal();
    }

    @Override
    public void func_149666_a(CreativeTabs itemIn, NonNullList<ItemStack> items) {
        for (EnumCobbleType type : EnumCobbleType.values())
            items.add(new ItemStack(this, 1, type.ordinal()));
    }

    @Override
    public MapColor func_180659_g(IBlockState state, IBlockAccess worldIn, BlockPos pos) {
        return state.func_177229_b(TYPE).getColor();
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        return func_176223_P().func_177226_a(TYPE, EnumCobbleType.byType(meta));
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(TYPE).ordinal();
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, TYPE);
    }

    public static enum EnumCobbleType implements IStringSerializable {
        GRANITE("granite", MapColor.field_151664_l),
        DIORITE("diorite", MapColor.field_151677_p),
        ANDESITE("andesite", MapColor.field_151665_m);

        private String name;
        private MapColor color;

        private static final EnumCobbleType[] TYPES = values();

        private EnumCobbleType(String name, MapColor color) {
            this.name = name;
            this.color = color;
        }

        @Override
        public String func_176610_l() {
            return name;
        }

        public MapColor getColor() {
            return color;
        }

        public static EnumCobbleType byType(int meta) {
            if (meta < 0 || meta > 2)
                meta = 0;
            return TYPES[meta];
        }
    }
}
