package betterwithmods.common.command;

import betterwithmods.common.entity.item.EntityItemBuoy;
import net.minecraft.command.*;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.JsonToNBT;
import net.minecraft.nbt.NBTException;
import net.minecraft.server.MinecraftServer;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.text.ITextComponent;

/**
 * We're going to need to get rid of the cosmetic EntityItem that pops up in your face with /give, since that causes dupe bugs somehow.
 */
public class CommandBuoyGive extends CommandGive
{
    /**
     * Callback for when the command is executed
     *
     * @param server The server instance
     * @param sender The sender who executed the command
     * @param args The arguments that were passed
     */
    @Override
    public void func_184881_a(MinecraftServer server, ICommandSender sender, String[] args) throws CommandException
    {
        if (args.length < 2) {
            throw new WrongUsageException("commands.give.usage");
        }
        else {
            EntityPlayer entityplayer = func_184888_a(server, sender, args[0]);
            Item item = func_147179_f(sender, args[1]);
            int i = args.length >= 3 ? func_175764_a(args[2], 1, 64) : 1;
            int j = args.length >= 4 ? func_175755_a(args[3]) : 0;
            ItemStack itemstack = new ItemStack(item, i, j);
            ITextComponent name = itemstack.func_151000_E();

            if (args.length >= 5) {
                String s = func_147178_a(sender, args, 4).func_150260_c();

                try {
                    itemstack.func_77982_d(JsonToNBT.func_180713_a(s));
                }
                catch (NBTException nbtexception) {
                    throw new CommandException("commands.give.tagError", nbtexception.getMessage());
                }
            }

            boolean flag = entityplayer.field_71071_by.func_70441_a(itemstack);

            if (flag) {
                entityplayer.field_70170_p.func_184148_a(null, entityplayer.field_70165_t, entityplayer.field_70163_u, entityplayer.field_70161_v, SoundEvents.field_187638_cR, SoundCategory.PLAYERS, 0.2F, ((entityplayer.func_70681_au().nextFloat() - entityplayer.func_70681_au().nextFloat()) * 0.7F + 1.0F) * 2.0F);
                entityplayer.field_71069_bz.func_75142_b();
            }
            if (flag && itemstack.func_190926_b()) {
                sender.func_174794_a(CommandResultStats.Type.AFFECTED_ITEMS, i);
            }
            else {
                sender.func_174794_a(CommandResultStats.Type.AFFECTED_ITEMS, i - itemstack.func_190916_E());
                EntityItemBuoy entityitem = new EntityItemBuoy(entityplayer.func_71019_a(itemstack, false));

                if (entityitem != null) {
                    entityitem.func_174868_q();
                    entityitem.func_145797_a(entityplayer.func_70005_c_());
                }
            }

            func_152373_a(sender, this, "commands.give.success", name, i, entityplayer.func_70005_c_());
        }
    }
}
